//
//Super Luigi's bot behavior
//This is probably a little hacky, but oh well!
//

local SPINSTATE = S_MARIO_SPIN
local STARTUPTIME = TICRATE/3
local ABILITYTIME = TICRATE*4
rawset(_G, "CR_MARIOSPIN", 64)

addHook("MobjMoveCollide", function(mo, mobj)
	local player = mo.player
	local bot = mobj.player
	if not (G_CoopGametype() and player and bot and IsMario(mo)
	and not player.speed and not bot.speed) then return end
	
	//Squashing other players
	if (not bot.mariosquashed or bot.mariosquashstart >= TICRATE)
	and mo.state == S_PLAY_MELEE_LANDING and player.pflags & PF_GODMODE
		bot.mariosquashstart = 0
		bot.mariosquashed = TICRATE*10
		
		MarioDoStars(mobj)
		S_StartSound(mobj, sfx_mrhhit)
		S_StartSound(mobj, sfx_mario5)
		
	//Super Spin Jump
	elseif not mobj.luigihelper and IsMario(mobj)
	and P_IsObjectOnGround(mobj) and (bot.bot or bot.mariocrouch)
	and P_AproxDistance((mobj.z + mobj.height/2) - (mo.z + mobj.height/2),
	P_AproxDistance(mobj.x - mo.x, mobj.y - mo.y)) <= mobj.radius*2
		mobj.luigihelper = player
	end
end, MT_PLAYER)

addHook("PlayerThink", function(bot)
	local mobj = bot.mo
	local player = mobj and mobj.luigihelper
	local mo = player and player.valid and player.mo
	if not mobj
		if bot.luigicam
			bot.camerascale = skins[bot.skin].camerascale
			bot.luigicam = false
		end
		return
	elseif not mo
		if mobj.luigiability
			P_ResetPlayer(bot)
			mobj.state = S_PLAY_FALL
			mobj.luigiability = 0
		end
		if mobj.luigihelper
			mobj.luigihelper = nil
		end
		if mobj.luigiindicator and mobj.luigiindicator.valid
			P_RemoveMobj(mobj.luigiindicator)
		end
		if bot.luigicam
			bot.camerascale = skins[bot.skin].camerascale
			bot.luigicam = false
		end
		return
	end
	
	//During ability
	if mobj.luigiability
		if P_IsObjectOnGround(mo) or -mobj.luigiability >= ABILITYTIME
		or (mobj.luigiability < 0 and (bot.powers[pw_carry] != CR_MARIOSPIN
		or bot.pflags & PF_JUMPED or not player.mariospinjump))
			if player.mariospinjump
				mo.momx = $/2
				mo.momy = $/2
				mo.state = S_PLAY_SPRING
			end
			
			mobj.momx = mo.momx
			mobj.momy = mo.momy
			
			mobj.state = bot.pflags & PF_JUMPED and S_PLAY_JUMP or S_PLAY_SPRING
			P_ResetPlayer(bot)
			mobj.luigiability = 0
			
			return
			
		elseif mobj.luigiability > 0
			player.pflags = $ | PF_FULLSTASIS
			
			mobj.luigiability = $ + 1
			if mobj.luigiability >= STARTUPTIME
				mo.momz = 0
				mobj.luigiability = -1
				
				player.mariospinjump = 1
				player.mariospinsfx = -22
				mo.state = SPINSTATE
				
				player.glidetime = 0
				S_StartSound(mo, sfx_mrspun)
				MarioPlayVoice(player, "spinjump")
				
				P_ResetPlayer(bot)
				mobj.tracer = mo
				bot.powers[pw_carry] = CR_MARIOSPIN
				S_StartSound(mobj, sfx_s3k4a)
			end
			
		else
			mobj.luigiability = $ - 1
			bot.drawangle = player.drawangle
			mo.momz = 0
			
			//Thrust (both players have influence)
			local playerdir = player.mariopressdirection and not (player.bot and player.bot != 2)
			local botdir = bot.mariopressdirection and not (bot.bot and bot.bot != 2)
			local angle = R_PointToAngle2(0,0,mo.momx,mo.momy)
			if (playerdir and botdir)
			or mobj.luigiability >= -2
				local diff = player.marioinputangle - bot.marioinputangle
				angle = player.marioinputangle - diff/2
			elseif playerdir
				angle = player.marioinputangle
			elseif botdir
				angle = bot.marioinputangle
			end
			P_InstaThrust(mo, angle, FixedMul(player.normalspeed, mo.scale))
			
			//Ghost effect
			if not (mobj.luigiability % 3)
				P_SpawnGhostMobj(mo)
				P_SpawnGhostMobj(mobj)
			end
			
			//Move the bot under the player they're holding onto
			if P_MobjFlip(mo) < 0
				if mo.z + mo.height + mobj.height + mobj.scale <= mo.ceilingz
				and P_MobjFlip(mobj) < 0
					mobj.z = mo.z + mo.height
				else
					bot.powers[pw_carry] = CR_NONE
					return
				end
			else
				if mo.z - mobj.height - mobj.scale >= mo.floorz
				and P_MobjFlip(mobj) >= 0
					mobj.z = mo.z - mobj.height
				else
					bot.powers[pw_carry] = CR_NONE
					return
				end
			end
			
			//Move horizontally, get momentum
			P_TryMove(mobj, mo.x + P_ReturnThrustX(mo, player.drawangle, 4*FRACUNIT), mo.y + P_ReturnThrustY(mo, player.drawangle, 4*FRACUNIT), true)
			mobj.momx = mo.momx
			mobj.momy = mo.momy
			mobj.momz = mo.momz
			
			//State
			if mobj.state != S_PLAY_RIDE
				mobj.state = S_PLAY_RIDE
			end
			
			//Cancel on distance
			if P_AproxDistance(mobj.x - mo.x, mobj.y - mo.y) > mobj.radius
				bot.powers[pw_carry] = CR_NONE
				return
			end
		end
		
		if bot.bot and bot.bot != 2
			bot.pflags = $ | PF_FULLSTASIS
		end
		
		//Camera zoom
		player.luigicam = true
		bot.luigicam = true
		player.camerascale = skins[player.skin].camerascale*3/2
		bot.camerascale = skins[bot.skin].camerascale*3/2
		
	//Start ability
	elseif player.pflags & PF_JUMPED and player.cmd.buttons & BT_JUMP
	and player.pflags & PF_STARTJUMP and mo.momz*P_MobjFlip(mo) > 0
		mobj.luigiability = 1
		P_SetObjectMomZ(mo, 24*FRACUNIT, false)
		P_SetObjectMomZ(mobj, 16*FRACUNIT, false)
		
		player.pflags = $ | PF_FULLSTASIS
		player.glidetime = -1
		
		bot.pflags = $ | PF_FULLSTASIS
		bot.glidetime = -1
		
		mo.state = S_PLAY_TWINSPIN
		mobj.state = S_PLAY_TWINSPIN
		
		MarioPlayVoice(bot, "spinjump")
		if mobj.luigiindicator and mobj.luigiindicator.valid
			P_RemoveMobj(mobj.luigiindicator)
		end
		
	elseif bot.bot and bot.bot != 2 and player.mariopressspin == 1
		ResetMario(bot, false, true)
		DoMarioHammer(bot, false, true)
		
	else
		if not (mobj.luigiindicator and mobj.luigiindicator.valid)
			mobj.luigiindicator = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_OVERLAY)
			mobj.luigiindicator.target = mobj
			mobj.luigiindicator.state = S_FLIGHTINDICATOR
			if not (consoleplayer == player or secondarydisplayplayer == player)
				mobj.luigiindicator.flags2 = $ | MF2_DONTDRAW
			end
		end
		mobj.luigihelper = nil
	end
end)